// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from mavros_msgs:msg/Vibration.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "mavros_msgs/msg/vibration.hpp"


#ifndef MAVROS_MSGS__MSG__DETAIL__VIBRATION__TRAITS_HPP_
#define MAVROS_MSGS__MSG__DETAIL__VIBRATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "mavros_msgs/msg/detail/vibration__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'vibration'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace mavros_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Vibration & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: vibration
  {
    out << "vibration: ";
    to_flow_style_yaml(msg.vibration, out);
    out << ", ";
  }

  // member: clipping
  {
    if (msg.clipping.size() == 0) {
      out << "clipping: []";
    } else {
      out << "clipping: [";
      size_t pending_items = msg.clipping.size();
      for (auto item : msg.clipping) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Vibration & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: vibration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vibration:\n";
    to_block_style_yaml(msg.vibration, out, indentation + 2);
  }

  // member: clipping
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.clipping.size() == 0) {
      out << "clipping: []\n";
    } else {
      out << "clipping:\n";
      for (auto item : msg.clipping) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Vibration & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace mavros_msgs

namespace rosidl_generator_traits
{

[[deprecated("use mavros_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const mavros_msgs::msg::Vibration & msg,
  std::ostream & out, size_t indentation = 0)
{
  mavros_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use mavros_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const mavros_msgs::msg::Vibration & msg)
{
  return mavros_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<mavros_msgs::msg::Vibration>()
{
  return "mavros_msgs::msg::Vibration";
}

template<>
inline const char * name<mavros_msgs::msg::Vibration>()
{
  return "mavros_msgs/msg/Vibration";
}

template<>
struct has_fixed_size<mavros_msgs::msg::Vibration>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Vector3>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<mavros_msgs::msg::Vibration>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Vector3>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<mavros_msgs::msg::Vibration>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MAVROS_MSGS__MSG__DETAIL__VIBRATION__TRAITS_HPP_
